#!/bin/bash
#
# landisk-update.sh
#
# $Id$
#

PATH=/usr/local/sbin:/usr/local/bin:/sbin:/bin:/usr/sbin:/usr/bin

MODEL=`sed -n '/^model/s/^model	//p' /etc/landisk/conffiles/config-system`

ROOTPATH='/mnt/hda5/.update'

VERFILE="${ROOTPATH}/for_${MODEL}_series"
UPFILE="/boot/.update/update.tgz"
TARFILE="${ROOTPATH}/update-files.tar.gz"
BETAFILE="${ROOTPATH}/beta"
UPPERL="${ROOTPATH}/update.pl"
CONFDIR='/mnt/hda5/landisk/conffiles'

UPDATEVER=`sed 's/-.*$//' $VERFILE`
if [ "$MODEL" = "HDL-GW" -o "$MODEL" = "HDL-GZ" ]; then
    UPDATESUBVER=`sed 's/^[0-9]*\.[0-9]*//' $VERFILE`
fi
[ -f $BETAFILE ] && BETA=`cat $BETAFILE`

start_led() {
   /usr/local/bin/ledcont stsfastblink 
}

exit_select() {
#    /usr/local/bin/ledcont errfastblink
#    /usr/local/bin/buzcont 10 50 3
    exit $1
}

#####################
# conffilesの更新
#####################
__update_conffiles() {
	# config-smbにmsdfsエントリを追加する
	sed -e '/^global/,/^[a-zA-Z0-9]/{/host_msdfs/D}' \
	    -e '/^global/a\	host_msdfs	no' \
	    -e '/^global/,/^[a-zA-Z0-9]/{/msdfs_root/D}' \
	    -e '/^global/a\	msdfs_root	no' \
	    ${CONFDIR}/config-smb > /tmp/.config-smb || return 1

	mv /tmp/.config-smb ${CONFDIR}/config-smb || return 1
	chown 0:0 ${CONFDIR}/config-smb
	chmod 666 ${CONFDIR}/config-smb

	# 1.13 ftp bug fix
	sed 's/local_umask\t022/local_umask\t002/' $CONFDIR/config-ftp > /tmp/.config-ftp 2>/dev/null || return 1
	mv /tmp/.config-ftp ${CONFDIR}/config-ftp || return 1
	chown 0:0 ${CONFDIR}/config-ftp
	chmod 666 ${CONFDIR}/config-ftp
	sed 's/local_umask=022/local_umask=002/' /etc/vsftpd.conf > /tmp/.vsftpd.conf 2>/dev/null || return 1
	mv /tmp/.vsftpd.conf /etc/vsftpd.conf || return 1
	chown 0:0 /etc/vsftpd.conf
	chmod 644 /etc/vsftpd.conf

	return 0
}

########################
# start
start_led


# perlでアップデート
${UPPERL} --update
if [ $? != 0 ]; then
    exit_select 3
fi

# サービスの停止の布石
SERVICE=`${UPPERL} --getservice 2>/dev/null | awk -F '=' '{print $1}'`

# remount rw /
mount -o remount,rw,noatime /

# サービスの停止
for i in $SERVICE apache2 HDLFind.sh cron xinetd sysklogd networking
do
    /etc/init.d/$i stop
done

# 必要であれば
#killall buttond
#killall usbhdmng

# bash のmove
mv /bin/bash /bin/bash.old

# tarで展開
# dlna databaseは上書きしない(1.10)
if [ -d /mnt/hda5/dmsf_data ]; then
	tar xpzf ${TARFILE} -C / --exclude ./mnt/hda5/dmsf_data || exit_select 1
else
	tar xpzf ${TARFILE} -C / || exit_select 1
	# 空フォルダ
	mkdir /mnt/hda5/dmsf_data/conf/access/allow
	mkdir /mnt/hda5/dmsf_data/conf/access/deny
	mkdir /mnt/hda5/dmsf_data/conf/sync/data
fi

# conffilesのアップデート
__update_conffiles || exit_select 1

# ファイルを削除する
rm -f $UPFILE $TARFILE $BETAFILE $VERFILE

# 1.12処理
pushd . >& /dev/null
cd /usr/local/www >& /dev/null
rm -f *.g *.gwz *.gx *.gxr *.htm index.html HDLraid.pm >& /dev/null
popd >& /dev/null

# 終了処理
upopts=--setversion=$UPDATEVER
[ "$UPDATESUBVER" != "" ] && upopts="$upopts --setsubversion=$UPDATESUBVER"
[ "$BETA" != "" ] && upopts="$upopts --setbeta=$BETA"

echo ${UPPERL} $upopts >/dev/console
${UPPERL} $upopts
rm -f $UPPERL
echo "success($UPDATEVER)" > /mnt/hda5/.update/update.log
